clear

%%Global Settings%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Experiment for univariate(=1) or multivariate(=2)?
num_var = [2;3;4];
%num_var = 2;

%1:gaussian, 2:uniform, 3:epanechnikov
kernel = 1;

%Give the value of bandwidth. When h=0, we use optimal bandwidth suggested by other settings
h=0;

%Number of observations
n = [100;200;300;400;500];
%n = 50

%# of grid points for estimation. Large grid points make calculation longer, but the graph smoother. 
grid_point = 300;

%Sum of exponent of Cobb Douglas function
sum_exp = [0.4;0.8];
%sum_exp = 0.4

%Variance of the error term%sigma = [0.7;1.4];
sigma = [0.7;1.4];
%sigma = 0.7

%Min and Max of observed X
minx_unif=1;
maxx_unif=10;

%Random data or fixed data? (0: fixed data, 1: random data)
random = 0;

%Additive or Multiplicative? (0: Additive, 1:multiplicative)
error_model = 1;

%Use same number of grid as number of observations? (0:no, 1:yes)
SameGridObs = 1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%KNN selection method, 1:Leave-One-Out CV, 2:General CV (based on Local Constant) , 3:10% of obs
selection=3;

%Debug purpose: Select Particular Experiment to see the result (Default = 0)
select_exp = 0;

experiment_number = 1


for i = 1:length(sum_exp)
    for j = 1:length(num_var)
        for k = 1:length(n)
            for l = 1:length(sigma)
                if SameGridObs == 1
                    grid_point=n(k);
                end
                if select_exp==0 | experiment_number == select_exp
                    [MSE(experiment_number,1),MSE(experiment_number,2), t(experiment_number),grd_drop(experiment_number),flagBW(experiment_number)] = LLKwSCtest(sum_exp(i),num_var(j),n(k),sigma(l),kernel,grid_point,minx_unif,maxx_unif,selection,random,error_model);
                    Setting(experiment_number,:) = [sum_exp(i),num_var(j),n(k),sigma(l)];
                end
                experiment_number = experiment_number + 1    
            end
        end
    end
end


fprintf('LLK KNN');
%[Setting, MSE, grd_drop', t', flagKNN']
final=[MSE, grd_drop', t', flagKNN']
mypath = '\\tarzan1\graduate$\yakkun19\Downloads\Experiments\LLK_KNN';
Filename = 'Results_KNN.csv'
csvwrite(fullfile(mypath,Filename),final);
