function [h_opt,flag] = Opt_BW(X,y,kernel,selection)


n = size(y,1);
% size returns a vector of length 2 with height and width of x
d = size(X,2); 
% Reassign d with the value of d(2) makes d a scalar with the value indicating the 
% number of input variables
flag = 0;

%Small x is point for evaluation
%Capital X is observed points

l = zeros(n,d);

if kernel == 1
    %Gaussian kernel
    kerf = @(z) exp(-z.*z/2)/sqrt(2*pi);

elseif kernel == 2
    %Uniform kernel
    kerf = @(z) 1/2*(abs(z)<=1);

elseif kernel == 3
    %Epanechnikov kernel
    kerf = @(z) 3/4*(1-z^2)*(abs(z)<=1);
end




   %function of leave one out local linear kernel estimator 
    function [MSE] = LOO_CV(h)
        MSE = 0;
        for i = 1:n
            A = zeros(1+d,1+d);
            B = zeros(1+d,1);
            prod_k = ones(n,1);
            for jj = 1:n,
                if jj~=i, 
                    for kk = 1:d,    %Daisuke: loop to calculate product kernel
                       prod_k(jj) = prod_k(jj)*kerf((X(jj,kk)-X(i,kk))/h(kk));
                       %prod_k(jj) = prod_k(jj)*exp(-(X(jj,kk)-X(i,kk))/h_opt(kk).*(X(jj,kk)-X(i,kk))/h_opt(kk)/2)/sqrt(2*pi);
                    end
                end
            end

            for jj = 1:n,
                if jj~=i,
                    A = A + prod_k(jj)*[1,X(jj,:)-X(i,:)]'*[1,X(jj,:)-X(i,:)];
                    B = B + prod_k(jj)*[1,X(jj,:)-X(i,:)]'*y(jj);
                end
            end
            temp_est = inv(A)*B;
            ghat = temp_est(1);
            if isnan(ghat)
            else
                MSE = MSE + (y(i) - ghat)^2;
            end
        end    
    end


if selection == 2,
    h0=ones(d,1);
    %options = optimoptions(@fminunc,'Algorithm','quasi-newton');
    options = optimoptions('fminunc','Display','off');
    [h_opt,fval]=fminunc(@LOO_CV,h0,options);
    h_opt
    if all(h_opt >= 10)
        flag=1;
    end
elseif selection == 1,
    h_opt = std(X)*n^(-1/(4+d))
end








% cvx_begin
%     variable h_opt(d)
%     for i = 1:n,
%         
%         A = zeros(1+d,1+d);
%         B = zeros(1+d,1);
%         prod_k = ones(n-1,1);
%         row = 1;
%         for j = 1:n,
%             if j~=i, 
%                 for kk = 1:d,    %Daisuke: loop to calculate product kernel
%                    prod_k(row) = prod_k(row)*kerf((X(j,kk)-X(i,kk))/h_opt(kk));
%                 end
%                 row = row+1;
%             end
%         end
%         
%         row = 1;
%         for j = 1:n,
%             if j~=i,
%                 A = A + prod_k(row)*[1,X(j,:)-X(i,:)]'*[1,X(j,:)-X(i,:)];
%                 B = B + prod_k(row)*[1,X(j,:)-X(i,:)]'*y(j);
%                 row = row + 1;
%             end
%         end
%         temp_est = inv(A)*B;
%         ghat = temp_est(1);
%        
%         %[ghat] = LOO_KE(h_opt,i)
%         MSE = MSE + (y(i) - g_hat)^2
%     end
%     minimize(MSE)
% cvx_end 




 

end